package edu.nyu.scps.gridview;

import android.content.Context;
import android.content.res.Resources;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.util.TypedValue;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.GridView;
import android.widget.ImageView;


public class ImageAdapter extends BaseAdapter {
    private Context context;

    private int[] thumb = {
            R.drawable.sample_0,
            R.drawable.sample_1,
            R.drawable.sample_2,
            R.drawable.sample_3,
            R.drawable.sample_4,
            R.drawable.sample_5,
            R.drawable.sample_6,
            R.drawable.sample_7
    };

    public ImageAdapter(Context context) {
        this.context = context;
    }

    @Override
    public int getCount() {
        return 100;
    }

    @Override
    public Object getItem(int position) {
        Resources resources = context.getResources();
        Drawable drawable = resources.getDrawable(thumb[position % thumb.length]);
        return drawable;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        ImageView imageView;
        if (convertView == null) {
            //Convert 60 dp to pixels.
            Resources resources = context.getResources();
            DisplayMetrics displayMetrics = resources.getDisplayMetrics();
            int pixels = (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 60, displayMetrics);

            imageView = new ImageView(context);
            imageView.setLayoutParams(new GridView.LayoutParams(pixels, pixels));
            imageView.setAdjustViewBounds(false);
            imageView.setScaleType(ImageView.ScaleType.CENTER_CROP);
            int padding = (int)TypedValue.applyDimension(TypedValue.COMPLEX_UNIT_DIP, 8, displayMetrics);
            imageView.setPadding(padding, padding, padding, padding);
        } else {
            imageView = (ImageView)convertView;
        }

        imageView.setImageResource(thumb[position % thumb.length]);
        return imageView;
    }
}
